function [debug_ds] = create_log_dataset(~)
%% Create dataset from csv file
%
% Created by: Tor Eirik strem, 15.01.2014
% Modified by: Christoffer Ofstad, 07.02.2014

% Date string format
date_string_format = 'dd.mm.yyyy HH:MM:SS';

%Debugdata
DebugData = csvimport('Logfile.csv');

for r=2:size(DebugData,1)-1,
    Debug(r-1,1) = datenum(DebugData{r,1},date_string_format); % time
    Debug(r-1,2) = DebugData{r,2};                           
    Debug(r-1,3) = DebugData{r,3};                           
    Debug(r-1,4) = DebugData{r,4};                           
    Debug(r-1,5) = DebugData{r,5};                            
    Debug(r-1,6) = DebugData{r,6};                            
    Debug(r-1,7) = DebugData{r,7};                            
    Debug(r-1,8) = DebugData{r,8};                             
    Debug(r-1,9) = DebugData{r,9};                         
    Debug(r-1,10) = DebugData{r,10};                            
    Debug(r-1,11) = DebugData{r,11};                        
    Debug(r-1,12) = DebugData{r,12};                             
end

% Change the time vector of Debug with unique time samples
T_diff = etime(datevec(Debug(end,1)),datevec(Debug(2,1)));
T_s = T_diff/size(Debug,1);
T_0 = 0:T_s:T_diff;
for i=1:length(T_0),
    T_s_num = datenum(2013,1,1,0,0,T_0(i))-datenum(2013,1,1,0,0,0);
    T_unique(i) = T_s_num + Debug(2,1);
end
Debug(:,1) = T_unique(1:size(Debug,1))';

debug_ds = mat2dataset(Debug,'VarNames',{'time','samples',...
                       'Debug1','Debug2','Debug3','Debug4','Debug5',...
                       'Debug6','Debug7','Debug8','Debug9','Debug10'});

% Add time which starts at t=0 and ends t=end
TIME_mat = debug_ds.time;
time_start_vec = datevec(TIME_mat(1));
for i=1:length(TIME_mat),
    TIME_mat(i,2) = etime(datevec(debug_ds.time(i)),time_start_vec);
    if i <= length(TIME_mat)-1,
        TIME_mat(i+1,3) = etime(datevec(TIME_mat(i+1)),datevec(TIME_mat(i)));
    end
end
TIME_ds = mat2dataset(TIME_mat,'VarNames',...
    {'time','time0','time_diff'});

debug_ds = join(debug_ds,TIME_ds,'key','time','Type','outer',...
   'MergeKeys',true);
