%% Initialize global constants
%
% Created by Christoffer Ofstad, 20.02.2014

% global constants;
%Vessel parameters
constants.vessel.D=[5.0242e4 0 0; 0 2.7229e5 -4.3933e6; 0 -4.3933e6 4.1894e8];
constants.vessel.M=[5.3122e6 0 0; 0 8.2831e6 0; 0 0 3.7454e9];

%PID Controller
controller_wn=.1;
controller_zeta=1.5;
constants.controller.Kp=controller_wn^2*constants.vessel.M;
constants.controller.Kp3=.2.*constants.controller.Kp;
constants.controller.Kd=2*controller_zeta*controller_wn*constants.vessel.M;
constants.controller.Kd3=5.*constants.controller.Kd;
constants.controller.Ki=(0.03^3/10)*constants.vessel.M;
constants.controller.Ki_PID=(controller_wn^3/10)*constants.vessel.M;
clear controller_wn controller_zeta

%AFF controller
constants.aff.on=1;
constants.aff.delta=.1;
constants.aff.gamma=diag([1,1,0]);
constants.aff.gain.acceleration=constants.vessel.M;
constants.aff.gain.velocity=constants.vessel.D;

%Reference model
constants.reference.x=0;
constants.reference.y=0;
constants.reference.psi=0; %degrees
constants.reference.timeon_x=0;
constants.reference.timeon_y=0;
constants.reference.timeon_psi=0;
constants.reference.timeconstant.x=100;
constants.reference.timeconstant.y=100;
constants.reference.timeconstant.psi=100;

%Current parameters
constants.current.surge=0;
constants.current.sway=0;

%Wave parameters
global sigma wo

%tunable
wo = 1.1; 
Hs = 2.4; 

wmax = 3;
w = (0.0001:0.01:wmax)';
S = wavespec(7,[Hs,wo,3.3],w,0); 
sigma = sqrt(max(S));
lambda = lsqcurvefit('Slin',0.1,w,S);
constants.wave.sigma=sigma;
constants.wave.lambda=lambda;
constants.wave.w0=wo;
constants.waves.K=.1*constants.vessel.M;
clear wo Hs wmax w S sigma lambda


%Wave filter
constants.wavefilter.on=0;
constants.wavefilter.Q=1;
constants.wavefilter.zeta=.01;

%Frequency tracker
constants.tracker.highpass_timeconst=.3;
constants.tracker.initvalue=.8;
constants.tracker.upper_limit=1.3;
constants.tracker.lower_limit=.3;
constants.tracker.filter_start_cutoff=.05;
constants.tracker.filter_final_cutoff=.001;
constants.tracker.filter_gain=.01;

%Selective wave filter
constants.selective.on=0;
constants.selective.J_x=.8;
constants.selective.J_y=.8;
constants.selective.settle_time=100;
constants.selective.init_time=10;
